# DeploymentProfile

(Cloud) deployment and scaling configuration

## GET /v3/deploymentProfile

> Get all the deployment profiles you have created

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentProfile","description":"(Cloud) deployment and scaling configuration"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"DeploymentProfile":{"type":"object","required":["id","fleetIds","name","strategyType","minimumCapacity","bufferValue","bufferValueType","markedForDeletion","inUse","deploymentRegions","createdAt"],"properties":{"id":{"type":"string","format":"","description":"The deployment profile ID","readOnly":true},"fleetIds":{"type":"array","items":{"type":"string","format":""},"description":"IDs of the fleets in which this deployment profile is being used","readOnly":true},"name":{"type":"string","format":"","description":"This deployment profile's name"},"description":{"type":"string","format":"","description":"This deployment profile's description"},"strategyType":{"type":"integer","format":"integer","description":"Possible values:\n- 1: Round robin"},"minimumCapacity":{"type":"integer","format":"integer","description":"The minimum amount of game instances that should always be deployed for each deployment region in this deployment profile.\nCan be overridden per deployment region"},"maximumCapacity":{"type":"integer","format":"integer","description":"The maximum amount of game instances that can be deployed in each region. Can be overridden per region.\n`Null` value means that there is no `maximumCapacity`","nullable":true},"bufferValue":{"type":"integer","format":"integer","description":"Global buffer value, to be applied to individual deployment regions. Can be overridden per region"},"bufferValueType":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Absolute value\n- 1: Percentage value (must be accompanied by `bufferValueMin` and `bufferValueMax`)"},"bufferValueMin":{"type":"integer","format":"integer","description":"The minimum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too low","nullable":true},"bufferValueMax":{"type":"integer","format":"integer","description":"The maximum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too high","nullable":true},"markedForDeletion":{"type":"integer","format":"integer","description":"When `1`, `markedForDeletion` will propagate to all deployment regions of this deployment profile.\nScaling down will happen slowly as application instances get removed naturally.\nAfter all application instances are removed, the deployment profile is set to inactive","readOnly":true},"inUse":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Deployment profile has no active application instances\n- 1: Deployment profile has active application instance(s)","readOnly":true},"deploymentRegions":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentRegion"},"description":"All deployment regions of this deployment profile","readOnly":true},"createdAt":{"type":"integer","format":"integer","description":"Unix timestamp of creation time","readOnly":true}},"additionalProperties":false},"DeploymentRegion":{"type":"object","required":["id","name","i3dDcLocationIds","markedForDeletion","inUse"],"properties":{"id":{"type":"string","format":"","description":"This deployment region's ID","readOnly":true},"name":{"type":"string","format":"","description":"The name of the deployment region"},"i3dDcLocationIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"All the i3D.net DC location IDs configured for this deployment region. You can get available IDs via `GET /cloud/dcLocation`"},"i3dDcLocationIdsToBeRemoved":{"type":"array","items":{"type":"integer","format":"integer"},"description":"i3D.net data center location IDs scheduled for removal from this region"},"minimumCapacity":{"type":"integer","format":"integer","description":"The minimum amount of game instances that should always be deployed in this region.\n`Null` value means that the `minimumCapacity` provided in the deployment profile will persist","nullable":true},"maximumCapacity":{"type":"integer","format":"integer","description":"The maximum amount of game instances that can be deployed in this region.\n`Null` value means that the `maximumCapacity` provided in the deployment profile will persist","nullable":true},"bufferValue":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValue`, to be applied only to this deployment region.\n`Null` value means that the `bufferValue` provided in the deployment profile will persist","nullable":true},"bufferValueType":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueType`. Possible values:\n- 0: Absolute value\n- 1: Percentage value (must be accompanied by `bufferValueMin` and `bufferValueMax`)\n`Null` value means that the `bufferValueType` provided in the deployment profile will persist","nullable":true},"bufferValueMin":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMin`. The minimum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too low.\n`Null` value means that the `bufferValueMin` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"bufferValueMax":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMax`. The maximum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too high.\n`Null` value means that the `bufferValueMax` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"strategyType":{"type":"integer","format":"integer","description":"Override value for `DeploymentProfile.strategyType`. Possible values:\n- `0`: Use default\n- `1`: Round robin\n- `null`: The `strategyType` provided in the deployment profile will persist","nullable":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to `1`, all application instances will be gracefully removed inside the deployment region. Afterwards this deployment region will be set to inactive","readOnly":true},"containers":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainer"}},"inUse":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Deployment region has no active application instances\n- 1: Deployment region has active application instance(s)","readOnly":true}},"additionalProperties":false},"DeploymentContainer":{"type":"object","required":["id","markedForDeletion","containerLocations"],"properties":{"id":{"type":"string","format":"","description":"This deployment container's ID","readOnly":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed inside the container. Afterwards this container will be set to inactive","readOnly":true},"containerLocations":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainerLocation"}}},"additionalProperties":false},"DeploymentContainerLocation":{"type":"object","required":["id","cloudProviderId","dcLocationId","primaryInstanceTypeName","primaryInstanceTypeStatus","secondaryInstanceTypeStatus","markedForDeletion"],"properties":{"id":{"type":"string","format":"","description":"This deploymentContainerLocation's ID","readOnly":true},"cloudProviderId":{"type":"integer","format":"integer","description":"The cloud provider ID of this location. For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/get_v3_cloud_provider)"},"dcLocationId":{"type":"integer","format":"integer","description":"The ID of the data center. Find all possible values from [`GET /v3/cloud/dcLocation`](#/Cloud/get_v3_cloud_dcLocation)"},"primaryInstanceTypeName":{"type":"string","format":"","description":"The primary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"primaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either primary instance type is available or not","readOnly":true},"secondaryInstanceTypeName":{"type":"string","format":"","description":"The secondary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"secondaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either secondary instance type is available or not","readOnly":true},"cpuPlatform":{"type":"string","format":"","description":"The CPU platform to use for the given `cloudProviderId`. Find all possible values from [`GET /v3/cloud/cpuPlatform`](#/Cloud/get_v3_cloud_cpuPlatform).\nNull value means that a CPU platform is chosen automatically by the cloud provider.\nNote that this selector is not available on all cloud platforms","nullable":true,"deprecated":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed in this cloud location. After all application instances are removed this object will also be deleted","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentProfile":{"get":{"tags":["DeploymentProfile"],"summary":"Get all the deployment profiles you have created","operationId":"getDeploymentProfiles","parameters":[{"name":"RANGED-DATA","in":"header","description":"Example header and default range: RANGED-DATA:start=0,results=25","schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentProfile"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## POST /v3/deploymentProfile

> Create a new deployment profile

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentProfile","description":"(Cloud) deployment and scaling configuration"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"DeploymentProfile":{"type":"object","required":["id","fleetIds","name","strategyType","minimumCapacity","bufferValue","bufferValueType","markedForDeletion","inUse","deploymentRegions","createdAt"],"properties":{"id":{"type":"string","format":"","description":"The deployment profile ID","readOnly":true},"fleetIds":{"type":"array","items":{"type":"string","format":""},"description":"IDs of the fleets in which this deployment profile is being used","readOnly":true},"name":{"type":"string","format":"","description":"This deployment profile's name"},"description":{"type":"string","format":"","description":"This deployment profile's description"},"strategyType":{"type":"integer","format":"integer","description":"Possible values:\n- 1: Round robin"},"minimumCapacity":{"type":"integer","format":"integer","description":"The minimum amount of game instances that should always be deployed for each deployment region in this deployment profile.\nCan be overridden per deployment region"},"maximumCapacity":{"type":"integer","format":"integer","description":"The maximum amount of game instances that can be deployed in each region. Can be overridden per region.\n`Null` value means that there is no `maximumCapacity`","nullable":true},"bufferValue":{"type":"integer","format":"integer","description":"Global buffer value, to be applied to individual deployment regions. Can be overridden per region"},"bufferValueType":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Absolute value\n- 1: Percentage value (must be accompanied by `bufferValueMin` and `bufferValueMax`)"},"bufferValueMin":{"type":"integer","format":"integer","description":"The minimum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too low","nullable":true},"bufferValueMax":{"type":"integer","format":"integer","description":"The maximum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too high","nullable":true},"markedForDeletion":{"type":"integer","format":"integer","description":"When `1`, `markedForDeletion` will propagate to all deployment regions of this deployment profile.\nScaling down will happen slowly as application instances get removed naturally.\nAfter all application instances are removed, the deployment profile is set to inactive","readOnly":true},"inUse":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Deployment profile has no active application instances\n- 1: Deployment profile has active application instance(s)","readOnly":true},"deploymentRegions":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentRegion"},"description":"All deployment regions of this deployment profile","readOnly":true},"createdAt":{"type":"integer","format":"integer","description":"Unix timestamp of creation time","readOnly":true}},"additionalProperties":false},"DeploymentRegion":{"type":"object","required":["id","name","i3dDcLocationIds","markedForDeletion","inUse"],"properties":{"id":{"type":"string","format":"","description":"This deployment region's ID","readOnly":true},"name":{"type":"string","format":"","description":"The name of the deployment region"},"i3dDcLocationIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"All the i3D.net DC location IDs configured for this deployment region. You can get available IDs via `GET /cloud/dcLocation`"},"i3dDcLocationIdsToBeRemoved":{"type":"array","items":{"type":"integer","format":"integer"},"description":"i3D.net data center location IDs scheduled for removal from this region"},"minimumCapacity":{"type":"integer","format":"integer","description":"The minimum amount of game instances that should always be deployed in this region.\n`Null` value means that the `minimumCapacity` provided in the deployment profile will persist","nullable":true},"maximumCapacity":{"type":"integer","format":"integer","description":"The maximum amount of game instances that can be deployed in this region.\n`Null` value means that the `maximumCapacity` provided in the deployment profile will persist","nullable":true},"bufferValue":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValue`, to be applied only to this deployment region.\n`Null` value means that the `bufferValue` provided in the deployment profile will persist","nullable":true},"bufferValueType":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueType`. Possible values:\n- 0: Absolute value\n- 1: Percentage value (must be accompanied by `bufferValueMin` and `bufferValueMax`)\n`Null` value means that the `bufferValueType` provided in the deployment profile will persist","nullable":true},"bufferValueMin":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMin`. The minimum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too low.\n`Null` value means that the `bufferValueMin` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"bufferValueMax":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMax`. The maximum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too high.\n`Null` value means that the `bufferValueMax` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"strategyType":{"type":"integer","format":"integer","description":"Override value for `DeploymentProfile.strategyType`. Possible values:\n- `0`: Use default\n- `1`: Round robin\n- `null`: The `strategyType` provided in the deployment profile will persist","nullable":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to `1`, all application instances will be gracefully removed inside the deployment region. Afterwards this deployment region will be set to inactive","readOnly":true},"containers":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainer"}},"inUse":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Deployment region has no active application instances\n- 1: Deployment region has active application instance(s)","readOnly":true}},"additionalProperties":false},"DeploymentContainer":{"type":"object","required":["id","markedForDeletion","containerLocations"],"properties":{"id":{"type":"string","format":"","description":"This deployment container's ID","readOnly":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed inside the container. Afterwards this container will be set to inactive","readOnly":true},"containerLocations":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainerLocation"}}},"additionalProperties":false},"DeploymentContainerLocation":{"type":"object","required":["id","cloudProviderId","dcLocationId","primaryInstanceTypeName","primaryInstanceTypeStatus","secondaryInstanceTypeStatus","markedForDeletion"],"properties":{"id":{"type":"string","format":"","description":"This deploymentContainerLocation's ID","readOnly":true},"cloudProviderId":{"type":"integer","format":"integer","description":"The cloud provider ID of this location. For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/get_v3_cloud_provider)"},"dcLocationId":{"type":"integer","format":"integer","description":"The ID of the data center. Find all possible values from [`GET /v3/cloud/dcLocation`](#/Cloud/get_v3_cloud_dcLocation)"},"primaryInstanceTypeName":{"type":"string","format":"","description":"The primary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"primaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either primary instance type is available or not","readOnly":true},"secondaryInstanceTypeName":{"type":"string","format":"","description":"The secondary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"secondaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either secondary instance type is available or not","readOnly":true},"cpuPlatform":{"type":"string","format":"","description":"The CPU platform to use for the given `cloudProviderId`. Find all possible values from [`GET /v3/cloud/cpuPlatform`](#/Cloud/get_v3_cloud_cpuPlatform).\nNull value means that a CPU platform is chosen automatically by the cloud provider.\nNote that this selector is not available on all cloud platforms","nullable":true,"deprecated":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed in this cloud location. After all application instances are removed this object will also be deleted","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentProfile":{"post":{"tags":["DeploymentProfile"],"summary":"Create a new deployment profile","operationId":"createDeploymentProfile","requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeploymentProfile"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentProfile"}}}}},"403":{"description":"Invalid credentials"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/deploymentProfile/summary

> Get all the deployment profiles you have created

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentProfile","description":"(Cloud) deployment and scaling configuration"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"DeploymentProfileSummary":{"type":"object","required":["id","fleetIds","name","strategyType","minimumCapacity","bufferValue","bufferValueType","markedForDeletion","inUse","createdAt"],"properties":{"id":{"type":"string","format":"","description":"The deployment profile ID","readOnly":true},"fleetIds":{"type":"array","items":{"type":"string","format":""},"description":"IDs of the fleets in which this deployment profile is being used","readOnly":true},"name":{"type":"string","format":"","description":"This deployment profile's name"},"description":{"type":"string","format":"","description":"This deployment profile's description"},"strategyType":{"type":"integer","format":"integer","description":"Possible values:\n- 1: Round robin"},"minimumCapacity":{"type":"integer","format":"integer","description":"The minimum amount of game instances that should always be deployed for each deployment region in this deployment profile.\nCan be overridden per deployment region"},"maximumCapacity":{"type":"integer","format":"integer","description":"The maximum amount of game instances that can be deployed in each region. Can be overridden per region.\n`Null` value means that there is no `maximumCapacity`","nullable":true},"bufferValue":{"type":"integer","format":"integer","description":"Global buffer value, to be applied to individual deployment regions. Can be overridden per region"},"bufferValueType":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Absolute value\n- 1: Percentage value (must be accompanied by `bufferValueMin` and `bufferValueMax`)"},"bufferValueMin":{"type":"integer","format":"integer","description":"The minimum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too low","nullable":true},"bufferValueMax":{"type":"integer","format":"integer","description":"The maximum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too high","nullable":true},"markedForDeletion":{"type":"integer","format":"integer","description":"When `1`, `markedForDeletion` will propagate to all deployment regions of this deployment profile.\nScaling down will happen slowly as application instances get removed naturally.\nAfter all application instances are removed, the deployment profile is set to inactive","readOnly":true},"inUse":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Deployment profile has no active application instances\n- 1: Deployment profile has active application instance(s)","readOnly":true},"createdAt":{"type":"integer","format":"integer","description":"Unix timestamp of creation time","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentProfile/summary":{"get":{"tags":["DeploymentProfile"],"summary":"Get all the deployment profiles you have created","operationId":"getDeploymentProfileSummaries","parameters":[{"name":"RANGED-DATA","in":"header","description":"Example header and default range: RANGED-DATA:start=0,results=25","schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentProfileSummary"}}}}},"403":{"description":"Invalid credentials"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/deploymentProfile/{deploymentProfileId}

> Get the given deployment profile

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentProfile","description":"(Cloud) deployment and scaling configuration"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"DeploymentProfile":{"type":"object","required":["id","fleetIds","name","strategyType","minimumCapacity","bufferValue","bufferValueType","markedForDeletion","inUse","deploymentRegions","createdAt"],"properties":{"id":{"type":"string","format":"","description":"The deployment profile ID","readOnly":true},"fleetIds":{"type":"array","items":{"type":"string","format":""},"description":"IDs of the fleets in which this deployment profile is being used","readOnly":true},"name":{"type":"string","format":"","description":"This deployment profile's name"},"description":{"type":"string","format":"","description":"This deployment profile's description"},"strategyType":{"type":"integer","format":"integer","description":"Possible values:\n- 1: Round robin"},"minimumCapacity":{"type":"integer","format":"integer","description":"The minimum amount of game instances that should always be deployed for each deployment region in this deployment profile.\nCan be overridden per deployment region"},"maximumCapacity":{"type":"integer","format":"integer","description":"The maximum amount of game instances that can be deployed in each region. Can be overridden per region.\n`Null` value means that there is no `maximumCapacity`","nullable":true},"bufferValue":{"type":"integer","format":"integer","description":"Global buffer value, to be applied to individual deployment regions. Can be overridden per region"},"bufferValueType":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Absolute value\n- 1: Percentage value (must be accompanied by `bufferValueMin` and `bufferValueMax`)"},"bufferValueMin":{"type":"integer","format":"integer","description":"The minimum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too low","nullable":true},"bufferValueMax":{"type":"integer","format":"integer","description":"The maximum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too high","nullable":true},"markedForDeletion":{"type":"integer","format":"integer","description":"When `1`, `markedForDeletion` will propagate to all deployment regions of this deployment profile.\nScaling down will happen slowly as application instances get removed naturally.\nAfter all application instances are removed, the deployment profile is set to inactive","readOnly":true},"inUse":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Deployment profile has no active application instances\n- 1: Deployment profile has active application instance(s)","readOnly":true},"deploymentRegions":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentRegion"},"description":"All deployment regions of this deployment profile","readOnly":true},"createdAt":{"type":"integer","format":"integer","description":"Unix timestamp of creation time","readOnly":true}},"additionalProperties":false},"DeploymentRegion":{"type":"object","required":["id","name","i3dDcLocationIds","markedForDeletion","inUse"],"properties":{"id":{"type":"string","format":"","description":"This deployment region's ID","readOnly":true},"name":{"type":"string","format":"","description":"The name of the deployment region"},"i3dDcLocationIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"All the i3D.net DC location IDs configured for this deployment region. You can get available IDs via `GET /cloud/dcLocation`"},"i3dDcLocationIdsToBeRemoved":{"type":"array","items":{"type":"integer","format":"integer"},"description":"i3D.net data center location IDs scheduled for removal from this region"},"minimumCapacity":{"type":"integer","format":"integer","description":"The minimum amount of game instances that should always be deployed in this region.\n`Null` value means that the `minimumCapacity` provided in the deployment profile will persist","nullable":true},"maximumCapacity":{"type":"integer","format":"integer","description":"The maximum amount of game instances that can be deployed in this region.\n`Null` value means that the `maximumCapacity` provided in the deployment profile will persist","nullable":true},"bufferValue":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValue`, to be applied only to this deployment region.\n`Null` value means that the `bufferValue` provided in the deployment profile will persist","nullable":true},"bufferValueType":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueType`. Possible values:\n- 0: Absolute value\n- 1: Percentage value (must be accompanied by `bufferValueMin` and `bufferValueMax`)\n`Null` value means that the `bufferValueType` provided in the deployment profile will persist","nullable":true},"bufferValueMin":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMin`. The minimum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too low.\n`Null` value means that the `bufferValueMin` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"bufferValueMax":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMax`. The maximum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too high.\n`Null` value means that the `bufferValueMax` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"strategyType":{"type":"integer","format":"integer","description":"Override value for `DeploymentProfile.strategyType`. Possible values:\n- `0`: Use default\n- `1`: Round robin\n- `null`: The `strategyType` provided in the deployment profile will persist","nullable":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to `1`, all application instances will be gracefully removed inside the deployment region. Afterwards this deployment region will be set to inactive","readOnly":true},"containers":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainer"}},"inUse":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Deployment region has no active application instances\n- 1: Deployment region has active application instance(s)","readOnly":true}},"additionalProperties":false},"DeploymentContainer":{"type":"object","required":["id","markedForDeletion","containerLocations"],"properties":{"id":{"type":"string","format":"","description":"This deployment container's ID","readOnly":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed inside the container. Afterwards this container will be set to inactive","readOnly":true},"containerLocations":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainerLocation"}}},"additionalProperties":false},"DeploymentContainerLocation":{"type":"object","required":["id","cloudProviderId","dcLocationId","primaryInstanceTypeName","primaryInstanceTypeStatus","secondaryInstanceTypeStatus","markedForDeletion"],"properties":{"id":{"type":"string","format":"","description":"This deploymentContainerLocation's ID","readOnly":true},"cloudProviderId":{"type":"integer","format":"integer","description":"The cloud provider ID of this location. For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/get_v3_cloud_provider)"},"dcLocationId":{"type":"integer","format":"integer","description":"The ID of the data center. Find all possible values from [`GET /v3/cloud/dcLocation`](#/Cloud/get_v3_cloud_dcLocation)"},"primaryInstanceTypeName":{"type":"string","format":"","description":"The primary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"primaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either primary instance type is available or not","readOnly":true},"secondaryInstanceTypeName":{"type":"string","format":"","description":"The secondary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"secondaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either secondary instance type is available or not","readOnly":true},"cpuPlatform":{"type":"string","format":"","description":"The CPU platform to use for the given `cloudProviderId`. Find all possible values from [`GET /v3/cloud/cpuPlatform`](#/Cloud/get_v3_cloud_cpuPlatform).\nNull value means that a CPU platform is chosen automatically by the cloud provider.\nNote that this selector is not available on all cloud platforms","nullable":true,"deprecated":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed in this cloud location. After all application instances are removed this object will also be deleted","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentProfile/{deploymentProfileId}":{"get":{"tags":["DeploymentProfile"],"summary":"Get the given deployment profile","operationId":"getDeploymentProfile","parameters":[{"name":"deploymentProfileId","in":"path","description":"The Id of the deployment profile","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentProfile"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentProfileId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/deploymentProfile/{deploymentProfileId}

> Update given deployment profile

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentProfile","description":"(Cloud) deployment and scaling configuration"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"DeploymentProfile":{"type":"object","required":["id","fleetIds","name","strategyType","minimumCapacity","bufferValue","bufferValueType","markedForDeletion","inUse","deploymentRegions","createdAt"],"properties":{"id":{"type":"string","format":"","description":"The deployment profile ID","readOnly":true},"fleetIds":{"type":"array","items":{"type":"string","format":""},"description":"IDs of the fleets in which this deployment profile is being used","readOnly":true},"name":{"type":"string","format":"","description":"This deployment profile's name"},"description":{"type":"string","format":"","description":"This deployment profile's description"},"strategyType":{"type":"integer","format":"integer","description":"Possible values:\n- 1: Round robin"},"minimumCapacity":{"type":"integer","format":"integer","description":"The minimum amount of game instances that should always be deployed for each deployment region in this deployment profile.\nCan be overridden per deployment region"},"maximumCapacity":{"type":"integer","format":"integer","description":"The maximum amount of game instances that can be deployed in each region. Can be overridden per region.\n`Null` value means that there is no `maximumCapacity`","nullable":true},"bufferValue":{"type":"integer","format":"integer","description":"Global buffer value, to be applied to individual deployment regions. Can be overridden per region"},"bufferValueType":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Absolute value\n- 1: Percentage value (must be accompanied by `bufferValueMin` and `bufferValueMax`)"},"bufferValueMin":{"type":"integer","format":"integer","description":"The minimum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too low","nullable":true},"bufferValueMax":{"type":"integer","format":"integer","description":"The maximum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too high","nullable":true},"markedForDeletion":{"type":"integer","format":"integer","description":"When `1`, `markedForDeletion` will propagate to all deployment regions of this deployment profile.\nScaling down will happen slowly as application instances get removed naturally.\nAfter all application instances are removed, the deployment profile is set to inactive","readOnly":true},"inUse":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Deployment profile has no active application instances\n- 1: Deployment profile has active application instance(s)","readOnly":true},"deploymentRegions":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentRegion"},"description":"All deployment regions of this deployment profile","readOnly":true},"createdAt":{"type":"integer","format":"integer","description":"Unix timestamp of creation time","readOnly":true}},"additionalProperties":false},"DeploymentRegion":{"type":"object","required":["id","name","i3dDcLocationIds","markedForDeletion","inUse"],"properties":{"id":{"type":"string","format":"","description":"This deployment region's ID","readOnly":true},"name":{"type":"string","format":"","description":"The name of the deployment region"},"i3dDcLocationIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"All the i3D.net DC location IDs configured for this deployment region. You can get available IDs via `GET /cloud/dcLocation`"},"i3dDcLocationIdsToBeRemoved":{"type":"array","items":{"type":"integer","format":"integer"},"description":"i3D.net data center location IDs scheduled for removal from this region"},"minimumCapacity":{"type":"integer","format":"integer","description":"The minimum amount of game instances that should always be deployed in this region.\n`Null` value means that the `minimumCapacity` provided in the deployment profile will persist","nullable":true},"maximumCapacity":{"type":"integer","format":"integer","description":"The maximum amount of game instances that can be deployed in this region.\n`Null` value means that the `maximumCapacity` provided in the deployment profile will persist","nullable":true},"bufferValue":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValue`, to be applied only to this deployment region.\n`Null` value means that the `bufferValue` provided in the deployment profile will persist","nullable":true},"bufferValueType":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueType`. Possible values:\n- 0: Absolute value\n- 1: Percentage value (must be accompanied by `bufferValueMin` and `bufferValueMax`)\n`Null` value means that the `bufferValueType` provided in the deployment profile will persist","nullable":true},"bufferValueMin":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMin`. The minimum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too low.\n`Null` value means that the `bufferValueMin` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"bufferValueMax":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMax`. The maximum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too high.\n`Null` value means that the `bufferValueMax` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"strategyType":{"type":"integer","format":"integer","description":"Override value for `DeploymentProfile.strategyType`. Possible values:\n- `0`: Use default\n- `1`: Round robin\n- `null`: The `strategyType` provided in the deployment profile will persist","nullable":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to `1`, all application instances will be gracefully removed inside the deployment region. Afterwards this deployment region will be set to inactive","readOnly":true},"containers":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainer"}},"inUse":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Deployment region has no active application instances\n- 1: Deployment region has active application instance(s)","readOnly":true}},"additionalProperties":false},"DeploymentContainer":{"type":"object","required":["id","markedForDeletion","containerLocations"],"properties":{"id":{"type":"string","format":"","description":"This deployment container's ID","readOnly":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed inside the container. Afterwards this container will be set to inactive","readOnly":true},"containerLocations":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainerLocation"}}},"additionalProperties":false},"DeploymentContainerLocation":{"type":"object","required":["id","cloudProviderId","dcLocationId","primaryInstanceTypeName","primaryInstanceTypeStatus","secondaryInstanceTypeStatus","markedForDeletion"],"properties":{"id":{"type":"string","format":"","description":"This deploymentContainerLocation's ID","readOnly":true},"cloudProviderId":{"type":"integer","format":"integer","description":"The cloud provider ID of this location. For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/get_v3_cloud_provider)"},"dcLocationId":{"type":"integer","format":"integer","description":"The ID of the data center. Find all possible values from [`GET /v3/cloud/dcLocation`](#/Cloud/get_v3_cloud_dcLocation)"},"primaryInstanceTypeName":{"type":"string","format":"","description":"The primary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"primaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either primary instance type is available or not","readOnly":true},"secondaryInstanceTypeName":{"type":"string","format":"","description":"The secondary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"secondaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either secondary instance type is available or not","readOnly":true},"cpuPlatform":{"type":"string","format":"","description":"The CPU platform to use for the given `cloudProviderId`. Find all possible values from [`GET /v3/cloud/cpuPlatform`](#/Cloud/get_v3_cloud_cpuPlatform).\nNull value means that a CPU platform is chosen automatically by the cloud provider.\nNote that this selector is not available on all cloud platforms","nullable":true,"deprecated":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed in this cloud location. After all application instances are removed this object will also be deleted","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentProfile/{deploymentProfileId}":{"put":{"tags":["DeploymentProfile"],"summary":"Update given deployment profile","operationId":"updateDeploymentProfile","parameters":[{"name":"deploymentProfileId","in":"path","description":"The Id of the deployment profile","required":true,"schema":{"type":"string"}}],"requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeploymentProfile"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentProfile"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentProfileId"},"409":{"description":"The deployment profile can't be updated because it is marked for deletion"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## Delete given deployment profile (it will delete all the application instances if there are any)

> A task will be created and returned (response 200) if the deployment profile is in use, the deployment profile will be mark for deletion and after all the application instances are deleted the deployment profile will be deleted.\
> If not in use, then the deployment profile will be immediately deleted and no content will be returned (status 204)

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentProfile","description":"(Cloud) deployment and scaling configuration"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"TaskStatus":{"type":"object","required":["id","name","batchId","categoryId","entityId","currentActionIdx","executeAt","lastActivityAt","finishedAt","resultCode","resultText"],"properties":{"id":{"type":"integer","format":"integer","description":"Task ID","readOnly":true},"name":{"type":"string","format":"","description":"Task name","readOnly":true},"batchId":{"type":"integer","format":"integer","description":"The ID of the batch the task belongs to","readOnly":true},"categoryId":{"type":"integer","format":"integer","description":"The ID of the task category. Valid values are:\n- 1: game server","readOnly":true},"entityId":{"type":"integer","format":"integer","description":"The ID of the entity the task is being executed for. E.g. a game server ID (categoryId 1)","readOnly":true},"currentActionIdx":{"type":"integer","format":"integer","description":"Currently active action index - relates to the action index as found in the template.","readOnly":true},"executeAt":{"type":"integer","format":"integer","description":"Unix timestamp indicating the start of execution.","readOnly":true},"lastActivityAt":{"type":"integer","format":"integer","description":"Unix timestamp indicating lastest activity.","readOnly":true},"finishedAt":{"type":"integer","format":"integer","description":"Unix timestamp at which the task was finished.","readOnly":true},"resultCode":{"type":"integer","format":"integer","description":"The result of the task. 0: pending, 1: in progress, 2: paused, 125: cancelled, 126: done with error, 127: done","readOnly":true},"resultText":{"type":"string","format":"","description":"The result of the task in message form.","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentProfile/{deploymentProfileId}":{"delete":{"tags":["DeploymentProfile"],"summary":"Delete given deployment profile (it will delete all the application instances if there are any)","description":"A task will be created and returned (response 200) if the deployment profile is in use, the deployment profile will be mark for deletion and after all the application instances are deleted the deployment profile will be deleted.\nIf not in use, then the deployment profile will be immediately deleted and no content will be returned (status 204)","operationId":"deleteDeploymentProfile","parameters":[{"name":"methodId","in":"query","description":"Id for the method of deletion: hard-kill = 1, graceful=2","schema":{"type":"integer"}},{"name":"startTime","in":"query","description":"Unix timestamp. When to start deleting the containerLocation and its contents. Default = now","schema":{"type":"integer"}},{"name":"endTime","in":"query","description":"Unix timestamp. Time limit in which to delete all remaining game servers immediately (not graceful). Default = 0 (no limit)","schema":{"type":"integer"}},{"name":"deploymentProfileId","in":"path","description":"Id of the deployment profile to delete","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/TaskStatus"}}}}},"204":{"description":"No Content"},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentProfileId"},"409":{"description":"Unable to delete due to deployment profile being in-use"},"422":{"description":"Invalid startTime and/or endTime"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## GET /v3/deploymentRegion/{deploymentRegionId}

> Get the given deployment region

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentProfile","description":"(Cloud) deployment and scaling configuration"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"DeploymentRegion":{"type":"object","required":["id","name","i3dDcLocationIds","markedForDeletion","inUse"],"properties":{"id":{"type":"string","format":"","description":"This deployment region's ID","readOnly":true},"name":{"type":"string","format":"","description":"The name of the deployment region"},"i3dDcLocationIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"All the i3D.net DC location IDs configured for this deployment region. You can get available IDs via `GET /cloud/dcLocation`"},"i3dDcLocationIdsToBeRemoved":{"type":"array","items":{"type":"integer","format":"integer"},"description":"i3D.net data center location IDs scheduled for removal from this region"},"minimumCapacity":{"type":"integer","format":"integer","description":"The minimum amount of game instances that should always be deployed in this region.\n`Null` value means that the `minimumCapacity` provided in the deployment profile will persist","nullable":true},"maximumCapacity":{"type":"integer","format":"integer","description":"The maximum amount of game instances that can be deployed in this region.\n`Null` value means that the `maximumCapacity` provided in the deployment profile will persist","nullable":true},"bufferValue":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValue`, to be applied only to this deployment region.\n`Null` value means that the `bufferValue` provided in the deployment profile will persist","nullable":true},"bufferValueType":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueType`. Possible values:\n- 0: Absolute value\n- 1: Percentage value (must be accompanied by `bufferValueMin` and `bufferValueMax`)\n`Null` value means that the `bufferValueType` provided in the deployment profile will persist","nullable":true},"bufferValueMin":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMin`. The minimum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too low.\n`Null` value means that the `bufferValueMin` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"bufferValueMax":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMax`. The maximum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too high.\n`Null` value means that the `bufferValueMax` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"strategyType":{"type":"integer","format":"integer","description":"Override value for `DeploymentProfile.strategyType`. Possible values:\n- `0`: Use default\n- `1`: Round robin\n- `null`: The `strategyType` provided in the deployment profile will persist","nullable":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to `1`, all application instances will be gracefully removed inside the deployment region. Afterwards this deployment region will be set to inactive","readOnly":true},"containers":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainer"}},"inUse":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Deployment region has no active application instances\n- 1: Deployment region has active application instance(s)","readOnly":true}},"additionalProperties":false},"DeploymentContainer":{"type":"object","required":["id","markedForDeletion","containerLocations"],"properties":{"id":{"type":"string","format":"","description":"This deployment container's ID","readOnly":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed inside the container. Afterwards this container will be set to inactive","readOnly":true},"containerLocations":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainerLocation"}}},"additionalProperties":false},"DeploymentContainerLocation":{"type":"object","required":["id","cloudProviderId","dcLocationId","primaryInstanceTypeName","primaryInstanceTypeStatus","secondaryInstanceTypeStatus","markedForDeletion"],"properties":{"id":{"type":"string","format":"","description":"This deploymentContainerLocation's ID","readOnly":true},"cloudProviderId":{"type":"integer","format":"integer","description":"The cloud provider ID of this location. For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/get_v3_cloud_provider)"},"dcLocationId":{"type":"integer","format":"integer","description":"The ID of the data center. Find all possible values from [`GET /v3/cloud/dcLocation`](#/Cloud/get_v3_cloud_dcLocation)"},"primaryInstanceTypeName":{"type":"string","format":"","description":"The primary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"primaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either primary instance type is available or not","readOnly":true},"secondaryInstanceTypeName":{"type":"string","format":"","description":"The secondary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"secondaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either secondary instance type is available or not","readOnly":true},"cpuPlatform":{"type":"string","format":"","description":"The CPU platform to use for the given `cloudProviderId`. Find all possible values from [`GET /v3/cloud/cpuPlatform`](#/Cloud/get_v3_cloud_cpuPlatform).\nNull value means that a CPU platform is chosen automatically by the cloud provider.\nNote that this selector is not available on all cloud platforms","nullable":true,"deprecated":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed in this cloud location. After all application instances are removed this object will also be deleted","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentRegion/{deploymentRegionId}":{"get":{"tags":["DeploymentProfile"],"summary":"Get the given deployment region","operationId":"getDeploymentRegion","parameters":[{"name":"deploymentRegionId","in":"path","description":"The Id of the deployment region","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentRegion"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentRegionId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/deploymentRegion/{deploymentRegionId}

> Update given deployment region

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentProfile","description":"(Cloud) deployment and scaling configuration"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"DeploymentRegion":{"type":"object","required":["id","name","i3dDcLocationIds","markedForDeletion","inUse"],"properties":{"id":{"type":"string","format":"","description":"This deployment region's ID","readOnly":true},"name":{"type":"string","format":"","description":"The name of the deployment region"},"i3dDcLocationIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"All the i3D.net DC location IDs configured for this deployment region. You can get available IDs via `GET /cloud/dcLocation`"},"i3dDcLocationIdsToBeRemoved":{"type":"array","items":{"type":"integer","format":"integer"},"description":"i3D.net data center location IDs scheduled for removal from this region"},"minimumCapacity":{"type":"integer","format":"integer","description":"The minimum amount of game instances that should always be deployed in this region.\n`Null` value means that the `minimumCapacity` provided in the deployment profile will persist","nullable":true},"maximumCapacity":{"type":"integer","format":"integer","description":"The maximum amount of game instances that can be deployed in this region.\n`Null` value means that the `maximumCapacity` provided in the deployment profile will persist","nullable":true},"bufferValue":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValue`, to be applied only to this deployment region.\n`Null` value means that the `bufferValue` provided in the deployment profile will persist","nullable":true},"bufferValueType":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueType`. Possible values:\n- 0: Absolute value\n- 1: Percentage value (must be accompanied by `bufferValueMin` and `bufferValueMax`)\n`Null` value means that the `bufferValueType` provided in the deployment profile will persist","nullable":true},"bufferValueMin":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMin`. The minimum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too low.\n`Null` value means that the `bufferValueMin` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"bufferValueMax":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMax`. The maximum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too high.\n`Null` value means that the `bufferValueMax` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"strategyType":{"type":"integer","format":"integer","description":"Override value for `DeploymentProfile.strategyType`. Possible values:\n- `0`: Use default\n- `1`: Round robin\n- `null`: The `strategyType` provided in the deployment profile will persist","nullable":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to `1`, all application instances will be gracefully removed inside the deployment region. Afterwards this deployment region will be set to inactive","readOnly":true},"containers":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainer"}},"inUse":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Deployment region has no active application instances\n- 1: Deployment region has active application instance(s)","readOnly":true}},"additionalProperties":false},"DeploymentContainer":{"type":"object","required":["id","markedForDeletion","containerLocations"],"properties":{"id":{"type":"string","format":"","description":"This deployment container's ID","readOnly":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed inside the container. Afterwards this container will be set to inactive","readOnly":true},"containerLocations":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainerLocation"}}},"additionalProperties":false},"DeploymentContainerLocation":{"type":"object","required":["id","cloudProviderId","dcLocationId","primaryInstanceTypeName","primaryInstanceTypeStatus","secondaryInstanceTypeStatus","markedForDeletion"],"properties":{"id":{"type":"string","format":"","description":"This deploymentContainerLocation's ID","readOnly":true},"cloudProviderId":{"type":"integer","format":"integer","description":"The cloud provider ID of this location. For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/get_v3_cloud_provider)"},"dcLocationId":{"type":"integer","format":"integer","description":"The ID of the data center. Find all possible values from [`GET /v3/cloud/dcLocation`](#/Cloud/get_v3_cloud_dcLocation)"},"primaryInstanceTypeName":{"type":"string","format":"","description":"The primary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"primaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either primary instance type is available or not","readOnly":true},"secondaryInstanceTypeName":{"type":"string","format":"","description":"The secondary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"secondaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either secondary instance type is available or not","readOnly":true},"cpuPlatform":{"type":"string","format":"","description":"The CPU platform to use for the given `cloudProviderId`. Find all possible values from [`GET /v3/cloud/cpuPlatform`](#/Cloud/get_v3_cloud_cpuPlatform).\nNull value means that a CPU platform is chosen automatically by the cloud provider.\nNote that this selector is not available on all cloud platforms","nullable":true,"deprecated":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed in this cloud location. After all application instances are removed this object will also be deleted","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentRegion/{deploymentRegionId}":{"put":{"tags":["DeploymentProfile"],"summary":"Update given deployment region","operationId":"updateDeploymentRegion","parameters":[{"name":"deploymentRegionId","in":"path","description":"Id of the deployment region to update","required":true,"schema":{"type":"string"}}],"requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeploymentRegion"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentRegion"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentRegionId"},"409":{"description":"The deployment region can't be updated because it is marked for deletion"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## Delete given deployment profile region (it will delete all the application instances if there are any)

> A task will be created and returned (response 200) if the deployment region is in use, the deployment region will be mark for deletion and after all the application instances are deleted the deployment region will be deleted.\
> If not in use, then the deployment region will be immediately deleted and no content will be returned (status 204)

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentProfile","description":"(Cloud) deployment and scaling configuration"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"TaskStatus":{"type":"object","required":["id","name","batchId","categoryId","entityId","currentActionIdx","executeAt","lastActivityAt","finishedAt","resultCode","resultText"],"properties":{"id":{"type":"integer","format":"integer","description":"Task ID","readOnly":true},"name":{"type":"string","format":"","description":"Task name","readOnly":true},"batchId":{"type":"integer","format":"integer","description":"The ID of the batch the task belongs to","readOnly":true},"categoryId":{"type":"integer","format":"integer","description":"The ID of the task category. Valid values are:\n- 1: game server","readOnly":true},"entityId":{"type":"integer","format":"integer","description":"The ID of the entity the task is being executed for. E.g. a game server ID (categoryId 1)","readOnly":true},"currentActionIdx":{"type":"integer","format":"integer","description":"Currently active action index - relates to the action index as found in the template.","readOnly":true},"executeAt":{"type":"integer","format":"integer","description":"Unix timestamp indicating the start of execution.","readOnly":true},"lastActivityAt":{"type":"integer","format":"integer","description":"Unix timestamp indicating lastest activity.","readOnly":true},"finishedAt":{"type":"integer","format":"integer","description":"Unix timestamp at which the task was finished.","readOnly":true},"resultCode":{"type":"integer","format":"integer","description":"The result of the task. 0: pending, 1: in progress, 2: paused, 125: cancelled, 126: done with error, 127: done","readOnly":true},"resultText":{"type":"string","format":"","description":"The result of the task in message form.","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentRegion/{deploymentRegionId}":{"delete":{"tags":["DeploymentProfile"],"summary":"Delete given deployment profile region (it will delete all the application instances if there are any)","description":"A task will be created and returned (response 200) if the deployment region is in use, the deployment region will be mark for deletion and after all the application instances are deleted the deployment region will be deleted.\nIf not in use, then the deployment region will be immediately deleted and no content will be returned (status 204)","operationId":"deleteDeploymentRegion","parameters":[{"name":"methodId","in":"query","description":"Id for the method of deletion: hard-kill = 1, graceful=2","schema":{"type":"integer"}},{"name":"startTime","in":"query","description":"Unix timestamp. When to start deleting the containerLocation and its contents. Default = now","schema":{"type":"integer"}},{"name":"endTime","in":"query","description":"Unix timestamp. Time limit in which to delete all remaining game servers immediately (not graceful). Default = 0 (no limit)","schema":{"type":"integer"}},{"name":"deploymentRegionId","in":"path","description":"Id of the deployment profile region to delete","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/TaskStatus"}}}}},"204":{"description":"No Content"},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentRegionId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## POST /v3/deploymentProfile/{deploymentProfileId}/deploymentRegion

> Create a new deployment region for the given profile

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentProfile","description":"(Cloud) deployment and scaling configuration"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"DeploymentRegion":{"type":"object","required":["id","name","i3dDcLocationIds","markedForDeletion","inUse"],"properties":{"id":{"type":"string","format":"","description":"This deployment region's ID","readOnly":true},"name":{"type":"string","format":"","description":"The name of the deployment region"},"i3dDcLocationIds":{"type":"array","items":{"type":"integer","format":"integer"},"description":"All the i3D.net DC location IDs configured for this deployment region. You can get available IDs via `GET /cloud/dcLocation`"},"i3dDcLocationIdsToBeRemoved":{"type":"array","items":{"type":"integer","format":"integer"},"description":"i3D.net data center location IDs scheduled for removal from this region"},"minimumCapacity":{"type":"integer","format":"integer","description":"The minimum amount of game instances that should always be deployed in this region.\n`Null` value means that the `minimumCapacity` provided in the deployment profile will persist","nullable":true},"maximumCapacity":{"type":"integer","format":"integer","description":"The maximum amount of game instances that can be deployed in this region.\n`Null` value means that the `maximumCapacity` provided in the deployment profile will persist","nullable":true},"bufferValue":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValue`, to be applied only to this deployment region.\n`Null` value means that the `bufferValue` provided in the deployment profile will persist","nullable":true},"bufferValueType":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueType`. Possible values:\n- 0: Absolute value\n- 1: Percentage value (must be accompanied by `bufferValueMin` and `bufferValueMax`)\n`Null` value means that the `bufferValueType` provided in the deployment profile will persist","nullable":true},"bufferValueMin":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMin`. The minimum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too low.\n`Null` value means that the `bufferValueMin` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"bufferValueMax":{"type":"integer","format":"integer","description":"Override for `DeploymentProfile.bufferValueMax`. The maximum absolute `bufferValue` when using a percentage, to prevent `bufferValue` from going too high.\n`Null` value means that the `bufferValueMax` provided in the deployment profile will persist.\nNote: if this value is supplied (not `null`) with your request, `bufferValue` and `bufferValueType` become required parameters.\nSee `POST /deploymentProfile/{deploymentProfileId}` for more information","nullable":true},"strategyType":{"type":"integer","format":"integer","description":"Override value for `DeploymentProfile.strategyType`. Possible values:\n- `0`: Use default\n- `1`: Round robin\n- `null`: The `strategyType` provided in the deployment profile will persist","nullable":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to `1`, all application instances will be gracefully removed inside the deployment region. Afterwards this deployment region will be set to inactive","readOnly":true},"containers":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainer"}},"inUse":{"type":"integer","format":"integer","description":"Possible values:\n- 0: Deployment region has no active application instances\n- 1: Deployment region has active application instance(s)","readOnly":true}},"additionalProperties":false},"DeploymentContainer":{"type":"object","required":["id","markedForDeletion","containerLocations"],"properties":{"id":{"type":"string","format":"","description":"This deployment container's ID","readOnly":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed inside the container. Afterwards this container will be set to inactive","readOnly":true},"containerLocations":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentContainerLocation"}}},"additionalProperties":false},"DeploymentContainerLocation":{"type":"object","required":["id","cloudProviderId","dcLocationId","primaryInstanceTypeName","primaryInstanceTypeStatus","secondaryInstanceTypeStatus","markedForDeletion"],"properties":{"id":{"type":"string","format":"","description":"This deploymentContainerLocation's ID","readOnly":true},"cloudProviderId":{"type":"integer","format":"integer","description":"The cloud provider ID of this location. For a list of cloud providers see [`GET /v3/cloud/provider`](#/Cloud/get_v3_cloud_provider)"},"dcLocationId":{"type":"integer","format":"integer","description":"The ID of the data center. Find all possible values from [`GET /v3/cloud/dcLocation`](#/Cloud/get_v3_cloud_dcLocation)"},"primaryInstanceTypeName":{"type":"string","format":"","description":"The primary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"primaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either primary instance type is available or not","readOnly":true},"secondaryInstanceTypeName":{"type":"string","format":"","description":"The secondary instance type to use. Find all possible values from [`GET /v3/cloud/instanceType`](#/Cloud/get_v3_cloud_instanceType)","nullable":true},"secondaryInstanceTypeStatus":{"type":"integer","format":"integer","description":"It will show either secondary instance type is available or not","readOnly":true},"cpuPlatform":{"type":"string","format":"","description":"The CPU platform to use for the given `cloudProviderId`. Find all possible values from [`GET /v3/cloud/cpuPlatform`](#/Cloud/get_v3_cloud_cpuPlatform).\nNull value means that a CPU platform is chosen automatically by the cloud provider.\nNote that this selector is not available on all cloud platforms","nullable":true,"deprecated":true},"markedForDeletion":{"type":"integer","format":"integer","description":"If set to 1, all application instances will be gracefully removed in this cloud location. After all application instances are removed this object will also be deleted","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentProfile/{deploymentProfileId}/deploymentRegion":{"post":{"tags":["DeploymentProfile"],"summary":"Create a new deployment region for the given profile","operationId":"createDeploymentProfileDeploymentRegion","parameters":[{"name":"deploymentProfileId","in":"path","description":"The Id of the deployment profile","required":true,"schema":{"type":"string"}}],"requestBody":{"description":"","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DeploymentRegion"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/DeploymentRegion"}}}}},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentProfileId"},"409":{"description":"No new deployment region can be created for given deployment profile because it is marked for deletion"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## Delete given deployment profile container (it will delete all the application instances if there are any)

> A task will be created and returned (response 200) if the deployment container is in use, the deployment container will be mark for deletion and after all the application instances are deleted the deployment container will be deleted.\
> If not in use, then the deployment container will be immediately deleted and no content will be returned (status 204)

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentProfile","description":"(Cloud) deployment and scaling configuration"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"TaskStatus":{"type":"object","required":["id","name","batchId","categoryId","entityId","currentActionIdx","executeAt","lastActivityAt","finishedAt","resultCode","resultText"],"properties":{"id":{"type":"integer","format":"integer","description":"Task ID","readOnly":true},"name":{"type":"string","format":"","description":"Task name","readOnly":true},"batchId":{"type":"integer","format":"integer","description":"The ID of the batch the task belongs to","readOnly":true},"categoryId":{"type":"integer","format":"integer","description":"The ID of the task category. Valid values are:\n- 1: game server","readOnly":true},"entityId":{"type":"integer","format":"integer","description":"The ID of the entity the task is being executed for. E.g. a game server ID (categoryId 1)","readOnly":true},"currentActionIdx":{"type":"integer","format":"integer","description":"Currently active action index - relates to the action index as found in the template.","readOnly":true},"executeAt":{"type":"integer","format":"integer","description":"Unix timestamp indicating the start of execution.","readOnly":true},"lastActivityAt":{"type":"integer","format":"integer","description":"Unix timestamp indicating lastest activity.","readOnly":true},"finishedAt":{"type":"integer","format":"integer","description":"Unix timestamp at which the task was finished.","readOnly":true},"resultCode":{"type":"integer","format":"integer","description":"The result of the task. 0: pending, 1: in progress, 2: paused, 125: cancelled, 126: done with error, 127: done","readOnly":true},"resultText":{"type":"string","format":"","description":"The result of the task in message form.","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentContainer/{deploymentContainerId}":{"delete":{"tags":["DeploymentProfile"],"summary":"Delete given deployment profile container (it will delete all the application instances if there are any)","description":"A task will be created and returned (response 200) if the deployment container is in use, the deployment container will be mark for deletion and after all the application instances are deleted the deployment container will be deleted.\nIf not in use, then the deployment container will be immediately deleted and no content will be returned (status 204)","operationId":"deleteDeploymentContainer","parameters":[{"name":"methodId","in":"query","description":"Id for the method of deletion: hard-kill = 1, graceful=2","schema":{"type":"integer"}},{"name":"startTime","in":"query","description":"Unix timestamp. When to start deleting the containerLocation and its contents. Default = now","schema":{"type":"integer"}},{"name":"endTime","in":"query","description":"Unix timestamp. Time limit in which to delete all remaining game servers immediately (not graceful). Default = 0 (no limit)","schema":{"type":"integer"}},{"name":"deploymentContainerId","in":"path","description":"Id of the deployment profile container to delete","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/TaskStatus"}}}}},"204":{"description":"No Content"},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentContainerId"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## Delete given deployment profile containerLocation (it will delete all the application instances if there are any)

> A task will be created and returned (response 200) if the deployment container location is in use, the deployment container location will be mark for deletion and after all the application instances are deleted the deployment container location will be deleted.\
> If not in use, then the deployment container location will be immediately deleted and no content will be returned (status 204)

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentProfile","description":"(Cloud) deployment and scaling configuration"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"TaskStatus":{"type":"object","required":["id","name","batchId","categoryId","entityId","currentActionIdx","executeAt","lastActivityAt","finishedAt","resultCode","resultText"],"properties":{"id":{"type":"integer","format":"integer","description":"Task ID","readOnly":true},"name":{"type":"string","format":"","description":"Task name","readOnly":true},"batchId":{"type":"integer","format":"integer","description":"The ID of the batch the task belongs to","readOnly":true},"categoryId":{"type":"integer","format":"integer","description":"The ID of the task category. Valid values are:\n- 1: game server","readOnly":true},"entityId":{"type":"integer","format":"integer","description":"The ID of the entity the task is being executed for. E.g. a game server ID (categoryId 1)","readOnly":true},"currentActionIdx":{"type":"integer","format":"integer","description":"Currently active action index - relates to the action index as found in the template.","readOnly":true},"executeAt":{"type":"integer","format":"integer","description":"Unix timestamp indicating the start of execution.","readOnly":true},"lastActivityAt":{"type":"integer","format":"integer","description":"Unix timestamp indicating lastest activity.","readOnly":true},"finishedAt":{"type":"integer","format":"integer","description":"Unix timestamp at which the task was finished.","readOnly":true},"resultCode":{"type":"integer","format":"integer","description":"The result of the task. 0: pending, 1: in progress, 2: paused, 125: cancelled, 126: done with error, 127: done","readOnly":true},"resultText":{"type":"string","format":"","description":"The result of the task in message form.","readOnly":true}},"additionalProperties":false},"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentContainerLocation/{deploymentContainerLocationId}":{"delete":{"tags":["DeploymentProfile"],"summary":"Delete given deployment profile containerLocation (it will delete all the application instances if there are any)","description":"A task will be created and returned (response 200) if the deployment container location is in use, the deployment container location will be mark for deletion and after all the application instances are deleted the deployment container location will be deleted.\nIf not in use, then the deployment container location will be immediately deleted and no content will be returned (status 204)","operationId":"deleteDeploymentContainerLocation","parameters":[{"name":"methodId","in":"query","description":"Id for the method of deletion: hard-kill = 1, graceful=2","schema":{"type":"integer"}},{"name":"startTime","in":"query","description":"Unix timestamp. When to start deleting the containerLocation and its contents. Default = now","schema":{"type":"integer"}},{"name":"endTime","in":"query","description":"Unix timestamp. Time limit in which to delete all remaining game servers immediately (not graceful). Default = 0 (no limit)","schema":{"type":"integer"}},{"name":"deploymentContainerLocationId","in":"path","description":"Id of the deployment profile containerLocation to delete","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/TaskStatus"}}}}},"204":{"description":"No Content"},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentContainerLocationId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/deploymentProfile/{deploymentProfileId}/canceldelete

> Cancel the deletion of given deployment profile (it will stop deletion but what has been deleted is lost already)

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentProfile","description":"(Cloud) deployment and scaling configuration"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentProfile/{deploymentProfileId}/canceldelete":{"put":{"tags":["DeploymentProfile"],"summary":"Cancel the deletion of given deployment profile (it will stop deletion but what has been deleted is lost already)","operationId":"updateDeploymentProfileCanceldelete","parameters":[{"name":"deploymentProfileId","in":"path","description":"Id of the deployment profile to stop deleting","required":true,"schema":{"type":"string"}}],"responses":{"204":{"description":"No Content"},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentProfileId"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/deploymentRegion/{deploymentRegionId}/canceldelete

> Cancel deletion of given deployment region (it will stop deletion but what has been deleted is lost already)

```json
{"openapi":"3.0.1","info":{"title":"i3D.net One-Deployment-Platform Endpoints","version":"3.0.0"},"tags":[{"name":"DeploymentProfile","description":"(Cloud) deployment and scaling configuration"}],"servers":[{"url":"https://api.i3d.net"}],"security":[{"ApiKey":[]}],"components":{"securitySchemes":{"ApiKey":{"type":"apiKey","name":"PRIVATE-TOKEN","in":"header"}},"schemas":{"Error":{"type":"object","required":["errorCode","errorMessage","errors"],"properties":{"errorCode":{"type":"integer","format":"integer","description":"Error code"},"errorMessage":{"type":"string","format":"","description":"Error message"},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"},"description":"Error details"}},"additionalProperties":false},"ErrorDetails":{"type":"object","required":["property","message"],"properties":{"property":{"type":"string","format":"","description":"Property in which there is an error"},"message":{"type":"string","format":"","description":"Error message"}},"additionalProperties":false}}},"paths":{"/v3/deploymentRegion/{deploymentRegionId}/canceldelete":{"put":{"tags":["DeploymentProfile"],"summary":"Cancel deletion of given deployment region (it will stop deletion but what has been deleted is lost already)","operationId":"updateDeploymentRegionCanceldelete","parameters":[{"name":"deploymentRegionId","in":"path","description":"Id of the deployment region to stop deleting","required":true,"schema":{"type":"integer"}}],"responses":{"204":{"description":"No Content"},"403":{"description":"Invalid credentials"},"404":{"description":"Invalid deploymentRegionId"},"422":{"description":"Unprocessable Entity"},"500":{"description":"Internal Server Error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}}}}}
```

## PUT /v3/deploymentContainer/{deploymentContainerId}/canceldelete

> Cancel delete given cloud deployment container

```json
[...]
